<?php
	/**
	 * Plugin core file.
	 *
	 * @package     Xpdy
	 * @since    1.0.0.
	 */

	/**
	 * Plugin core class.
	 *
	 * @since    1.0.0.
	 */
class CORE_Xpdy {
	/**
	 * Construct the plugin.
	 */
	public function __construct() {
		add_action( 'plugins_loaded', array( $this, 'init' ) );
	}
	/**
	 * Initialize the plugin.
	 */
	public function init() {
		// Checks if WooCommerce is installed.
		if ( class_exists( 'WC_Integration' ) ) {
			// Include our integration class.
			include_once 'class-wc-xpdy.php';
			// Register the integration.
			add_filter( 'woocommerce_integrations', array( $this, 'add_integration' ) );
		}
	}
	/**
	 * Adds a new integration to WooCommerce.
	 *
	 * @param array $integrations an array of class names.
	 */
	public function add_integration( $integrations ) {
		$integrations[] = 'WC_Xpdy';
		return $integrations;
	}
}
