<?php
	/**
	 * Plugin wc file.
	 *
	 * @package     Xpdy
	 * @since    1.0.0.
	 */

	/**
	 * Plugin wc class.
	 *
	 * @since    1.0.0.
	 */
class WC_Xpdy extends WC_Integration {
	/**
	 * Init and hook in the integration.
	 */
	public function __construct() {
		global $woocommerce;
		$this->id                 = 'expedy';
		$this->method_title       = __( 'Expedy.fr - Parameters' );
		$this->method_description = __( 'Fill in your Expedy settings, as well as the desired personalization settings' );
		// Load the settings.
		$this->init_form_fields();
		$this->init_settings();
		// Define user set variables.
		$this->xpdy_time_shift          = $this->get_option( 'xpdy_time_shift' );
		$this->xpdy_sid          = $this->get_option( 'xpdy_sid' );
		$this->xpdy_token          = $this->get_option( 'xpdy_token' );
		$this->xpdy_printer_uid          = $this->get_option( 'xpdy_printer_uid' );
		$this->xpdy_printer_uid_backup          = $this->get_option( 'xpdy_printer_uid_backup' );
		$this->xpdy_sms_num          = $this->get_option( 'xpdy_sms_num' );

		$this->xpdy_printer_size          = $this->get_option( 'xpdy_printer_size' );
		$this->xpdy_print_on          = $this->get_option( 'xpdy_print_on' );

		$this->xpdy_logo_url          = $this->get_option( 'xpdy_logo_url' );
		$this->xpdy_title          = $this->get_option( 'xpdy_title' );
		$this->xpdy_company          = $this->get_option( 'xpdy_company' );
		$this->xpdy_company_id          = $this->get_option( 'xpdy_company_id' );
		$this->xpdy_adr1          = $this->get_option( 'xpdy_adr1' );
		$this->xpdy_adr2          = $this->get_option( 'xpdy_adr2' );
		$this->xpdy_zip          = $this->get_option( 'xpdy_zip' );
		$this->xpdy_city          = $this->get_option( 'xpdy_city' );
		$this->xpdy_phone          = $this->get_option( 'xpdy_phone' );
		$this->xpdy_email          = $this->get_option( 'xpdy_email' );
		$this->xpdy_short_opts          = $this->get_option( 'xpdy_short_opts' );
		$this->xpdy_print_nb          = $this->get_option( 'xpdy_print_nb' );
		$this->xpdy_multistore          = $this->get_option( 'xpdy_multistore' );

		global $xpdy_time_shift;
		global $xpdy_sid;
		global $xpdy_token;
		global $xpdy_printer_uid;
		global $xpdy_printer_uid_backup;
		global $xpdy_sms_num;

		global $xpdy_printer_size;
		global $xpdy_print_on;

		global $xpdy_logo_url;
		global $xpdy_title;
		global $xpdy_company;
		global $xpdy_company_id;
		global $xpdy_adr1;
		global $xpdy_adr2;
		global $xpdy_zip;
		global $xpdy_city;
		global $xpdy_phone;
		global $xpdy_email;
		global $xpdy_short_opts;
		global $xpdy_print_nb;
		global $xpdy_multistore;

		$xpdy_time_shift = $this->get_option( 'xpdy_time_shift' );
		$xpdy_sid = $this->get_option( 'xpdy_sid' );
		$xpdy_token = $this->get_option( 'xpdy_token' );
		$xpdy_printer_uid = $this->get_option( 'xpdy_printer_uid' );
		$xpdy_printer_uid_backup = $this->get_option( 'xpdy_printer_uid_backup' );
		$xpdy_sms_num = $this->get_option( 'xpdy_sms_num' );

		$xpdy_printer_size = $this->get_option( 'xpdy_printer_size' );
		$xpdy_print_on = $this->get_option( 'xpdy_print_on' );
		$xpdy_logo_url = $this->get_option( 'xpdy_logo_url' );
		$xpdy_title = $this->get_option( 'xpdy_title' );
		$xpdy_company = $this->get_option( 'xpdy_company' );
		$xpdy_company_id = $this->get_option( 'xpdy_company_id' );
		$xpdy_adr1 = $this->get_option( 'xpdy_adr1' );
		$xpdy_adr2 = $this->get_option( 'xpdy_adr2' );
		$xpdy_zip = $this->get_option( 'xpdy_zip' );
		$xpdy_city = $this->get_option( 'xpdy_city' );
		$xpdy_phone = $this->get_option( 'xpdy_phone' );
		$xpdy_email = $this->get_option( 'xpdy_email' );
		$xpdy_short_opts = $this->get_option( 'xpdy_short_opts' );
		$xpdy_print_nb = $this->get_option( 'xpdy_print_nb' );
		$xpdy_multistore = $this->get_option( 'xpdy_multistore' );

		// Actions.
		add_action( 'woocommerce_update_options_integration_' . $this->id, array( $this, 'process_admin_options' ) );
	}
	/**
	 * Initialize integration settings form fields.
	 */
	public function init_form_fields() {
		$this->form_fields = array(
			'xpdy_sid' => array(
				'title'             => __( 'Expedy.fr SID' ),
				'type'              => 'text',
				'id'       => 'xpdy_sid',
				'description'       => __( 'Input your Expedy SID' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_token' => array(
				'title'             => __( 'Expedy.fr Token' ),
				'type'              => 'text',
				'id'       => 'xpdy_token',
				'description'       => __( 'Input your Expedy Token' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_time_shift' => array(
				'title'             => __( 'Time Zone' ),
				'type'              => 'select',
				'id'       => 'xpdy_time_shift',
				'description'       => __( 'Select the time zone used by your WooCommerce' ),
				'desc_tip'          => true,
				'default'           => 0,
				'options' => array(
					'-12' => __( 'GMT -12' ),
					'-11' => __( 'GMT -11' ),
					'-10' => __( 'GMT -10' ),
					'-9' => __( 'GMT -9' ),
					'-8' => __( 'GMT -8' ),
					'-7' => __( 'GMT -7' ),
					'-6' => __( 'GMT -6' ),
					'-5' => __( 'GMT -5' ),
					'-4' => __( 'GMT -4' ),
					'-3' => __( 'GMT -3' ),
					'-2' => __( 'GMT -2' ),
					'-1' => __( 'GMT -1' ),
					'0' => __( 'GMT 00' ),
					'1' => __( 'GMT +1' ),
					'2' => __( 'GMT +2' ),
					'3' => __( 'GMT +3' ),
					'4' => __( 'GMT +4' ),
					'5' => __( 'GMT +5' ),
					'6' => __( 'GMT +6' ),
					'7' => __( 'GMT +7' ),
					'8' => __( 'GMT +8' ),
					'9' => __( 'GMT +9' ),
					'10' => __( 'GMT +10' ),
					'11' => __( 'GMT +11' ),
					'12' => __( 'GMT +12' ),
				),
				'css'      => 'width:400px;',
			),
			'xpdy_printer_uid' => array(
				'title'             => __( 'Printer ID' ),
				'type'              => 'text',
				'id'       => 'xpdy_printer_uid',
				'description'       => __( 'Input your printer\'s unique ID, ex: "FYPEI9RKZT4"' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_printer_uid_backup' => array(
				'title'             => __( 'Tandem Printer ID' ),
				'type'              => 'text',
				'id'       => 'xpdy_printer_uid_backup',
				'description'       => __( 'If needed, add the unique ID of your backup printer, ex: "89WDH3FONR5"' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_printer_size' => array(
				'title'             => __( 'Paper Size' ),
				'type'              => 'select',
				'id'       => 'xpdy_printer_size',
				'description'       => __( 'Select your printer\'s roll paper size' ),
				'desc_tip'          => true,
				'default'           => '58',
				'options' => array(
					'58' => __( '58mm' ),
					'80' => __( '80mm' ),
				),
				'css'      => 'width:400px;',
			),
			'xpdy_logo_url' => array(
				'title'             => __( 'URL Logo (max width 570px)' ),
				'type'              => 'text',
				'id'       => 'xpdy_logo_url',
				'description'       => __( 'If needed, input the direct URL to your logo, ex: "https://www.site.com/logo.jpg" ' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_title' => array(
				'title'             => __( 'Shop Name / Title' ),
				'type'              => 'text',
				'id'       => 'xpdy_title',
				'description'       => __( 'If needed, add a title to your printing request, ex: "ONLINE ORDER"' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_company' => array(
				'title'             => __( 'Name of the company' ),
				'type'              => 'text',
				'id'       => 'xpdy_company',
				'description'       => __( 'If needed, add the name of your company' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_company_id' => array(
				'title'             => __( 'Registration number' ),
				'type'              => 'text',
				'id'       => 'xpdy_company_id',
				'description'       => __( 'If needed, write your Company Registration Number ' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_adr1' => array(
				'title'             => __( 'Address (line 1)' ),
				'type'              => 'text',
				'id'       => 'xpdy_adr1',
				'description'       => __( 'If needed, write the address' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_adr2' => array(
				'title'             => __( 'Address (line 2)' ),
				'type'              => 'text',
				'id'       => 'xpdy_adr2',
				'description'       => __( 'If needed, write the address' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_zip' => array(
				'title'             => __( 'Postal Code' ),
				'type'              => 'text',
				'id'       => 'xpdy_zip',
				'description'       => __( 'If needed, write the Postal Code' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_city' => array(
				'title'             => __( 'City' ),
				'type'              => 'text',
				'id'       => 'xpdy_city',
				'description'       => __( 'If needed, add the city' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_phone' => array(
				'title'             => __( 'Phone number' ),
				'type'              => 'text',
				'id'       => 'xpdy_phone',
				'description'       => __( 'If needed, add a phone number' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_email' => array(
				'title'             => __( 'Email' ),
				'type'              => 'text',
				'id'       => 'xpdy_email',
				'description'       => __( 'If needed, add an email' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_short_opts' => array(
				'title'             => __( 'Product details' ),
				'type'              => 'select',
				'id'       => 'xpdy_short_opts',
				'description'       => __( 'Select the level of details to be printed for each product' ),
				'desc_tip'          => true,
				'default'           => '0',
				'options' => array(
					'0' => __( 'Print all options' ),
					'1' => __( 'Print just the minimal options' ),
				),
				'css'      => 'width:400px;',
			),
			'xpdy_print_on' => array(
				'title'             => __( 'Sending a printing request' ),
				'type'              => 'select',
				'id'       => 'xpdy_print_on',
				'description'       => __( 'Select the status needed for a printing request to be sent' ),
				'desc_tip'          => true,
				'default'           => 0,
				'options' => array(
					'0' => __( 'Print an order if its status is "paid" ' ),
					'1' => __( 'Print an order if its status is "in progress" ' ),
					'2' => __( 'Print an order if its status is "finished" ' ),
				),
				'css'      => 'width:400px;',
			),
			'xpdy_print_nb' => array(
				'title'             => __( 'Number of copies' ),
				'type'              => 'select',
				'id'       => 'xpdy_print_nb',
				'description'       => __( 'Select the number of identical copies to be printed' ),
				'desc_tip'          => true,
				'default'           => 1,
				'options' => array(
					'1' => __( 'Print it once' ),
					'2' => __( 'Print it twice' ),
					'3' => __( 'Print it three times' ),
				),
				'css'      => 'width:400px;',
			),
			'xpdy_sms_num' => array(
				'title'             => __( 'SMS notification (format: +33663954708)' ),
				'type'              => 'text',
				'id'       => 'xpdy_sms_num',
				'description'       => __( 'If needed, add a mobile phone number to receive a notification for each new order, ex : +33663954708 - An additional fee is applied for this option, contact us to learn more about it.' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
			'xpdy_multistore' => array(
				'title'             => __( 'MultiVendor/Multistore datastring (format: contact our support team)' ),
				'type'              => 'text',
				'id'       => 'xpdy_multistore',
				'description'       => __( 'Format: Vendor_id:Printer_uid, separated by ||  (example: 4:DESNBXP887K||4:DESHKTI4EOW||12:PTDETIOXZQ)' ),
				'desc_tip'          => true,
				'default'           => '',
				'css'      => 'width:400px;',
			),
		);
	}
}


